<?php

// require_once DOL_DOCUMENT_ROOT.'/core/class/vcard.class.php';

// dol_include_once('carddav/class/societe.carddav.class.php');
// dol_include_once('carddav/class/contact.carddav.class.php');
// dol_include_once('carddav/class/DolCardDav.class.php');



Class Synchro {


    /**
      @brief convert Doli Object in Vcard
      @return $object Vcard
     */
    public static function DolForServer($object) {
        global $langs;

        dol_include_once('core/class/vcard.class.php');

        $type = get_class($object);
        //We create VCard
        $v = new vCard();
        $v->setProdId('Dolibarr ' . DOL_VERSION);


        $v->setUid('DOLIBARR-CONTACTID-' . $object->id);

        if ($type == 'Contact') {
            $v->setName($object->lastname, $object->firstname, "", "", "");
            $v->setFormattedName($object->getFullName($langs));
        } elseif ($type == 'Societe'){
            $v->setName($object->nom, "", "", "");
        }
        
        if ($type == 'Contact') {
            // By default, all informations are for work (except phone_perso and phone_mobile)
            $v->setPhoneNumber($object->phone_pro, "PREF;WORK;VOICE");
            $v->setPhoneNumber($object->phone_mobile, "CELL;VOICE");
        } elseif ($type == 'Societe')
            $v->setPhoneNumber($object->phone, "PREF;WORK;VOICE");

        $v->setPhoneNumber($object->fax, "WORK;FAX");

        $v->setAddress("", "", $object->address, $object->town, "", $object->zip, ($object->country_code ? $object->country_id : ''), "WORK;POSTAL");
        $v->setLabel("", "", $object->address, $object->town, "", $object->zip, ($object->country_code ? $object->country_id : ''), "WORK");
        $v->setEmail($object->email, 'internet,pref');
        $v->setNote($object->note);

        if ($type == 'Contact') {
            $v->setTitle($object->poste);


            // Personal informations
            $v->setPhoneNumber($object->phone_perso, "HOME;VOICE");
            if ($object->birthday)
                $v->setBirthday($object->birthday);
        }



        //  VCard 
        $vcard = $v->getVCard();

        return $vcard;
    }

    /**
      @param string $vcard_string
      @param boolean $row false or object
      @return object stdClass
      ->fn
      ->email
      ->tel_mob
      ->fax
      ->tel
     */
    public static function ServerForDol($vcard_string, $row = false) {

        dol_include_once('carddav/class/vcardphp-1.1.2/vcard.php');
        dol_include_once('carddav/class/vcardphp-1.1.2/vbook.php');

        if ($row == false)
            $row = new stdClass();

        $line = explode("\n", $vcard_string);

        $cards = parse_vcards($line);

        list($key, $card ) = each($cards);


        $name = $card->getProperty('FN');
        $row->fn = $name->value;

        $nickname = $card->getProperty('NICKNAME');
        $row->nickname = $nickname->value;


        $email = $card->getProperty('EMAIL');
        $row->email = (!isset($email->value) ? '' : $email->value );

        $tel = $card->getProperties('TEL');
        $i = 0;
        if (is_array($tel))
            foreach ($tel as $subtel) {
                if ($subtel->params['TYPE'][0] == 'CELL')
                    $row->tel_mob = $subtel->value;
                elseif ($subtel->params['TYPE'][0] == 'FAX')
                    $row->fax = $subtel->value;
                else
                    $row->tel = $subtel->value;

                $i++;
            }

        $title = $card->getProperty('TITLE');
        $row->label = (!isset($title->value) ? '' : $title->value );

        $note = $card->getProperty('NOTE');
        $row->note = (!isset($note->value) ? '' : $note->value );

        $compagny = $card->getProperty('ORG');
        $row->compagny = (!isset($compagny->value) ? '' : $compagny->value );

        $birthday = $card->getProperty('BDAY');
        $row->birthday = (!isset($birthday->value) ? '' : $birthday->value );

        return $row;
    }

    /**
      @param $user object
      @param $user_carddav object
      @param boolean $row false or object
      @return object stdClass
      ->fn
      ->email
      ->tel_mob
      ->fax
      ->tel
     */
    public static function CheckLocal(User $user, $user_carddav, $row) {
        global $db;

        dol_include_once('carddav/class/DolCardDav.class.php');

        $DolCardDav = new DolCardDav($db);

        if (($check = $DolCardDav->fetch_from($user->id, '', 0, 0, $row->id, false, $user_carddav->id) ) && $check > 0) {
            $DolCardDav = self::FixLocal($user, $row, $DolCardDav);
        } else {

            $DolCardDav = self::FixLocal($user, $row, $DolCardDav);

            // Force Creation Row Sycnrho 
            $DolCardDav->carddav_id = trim($row->id);
            $DolCardDav->carddav_etag = trim($row->etag);
            $DolCardDav->statut = (int) 1;
            $DolCardDav->fk_user = (int) $user->id;
            $DolCardDav->fk_user_carddav = (int) $user_carddav->id;

            $DolCardDav->create($user);
        }


        $DolCardDav->update($user);

        return $row;
    }

    /**
      @fn FixLocal( User $user , $row, DolCardDav $DolCardDav)
      @param User $user object
      @param stdClass current row object
      @param DolCardDav $DolCardDav object
      @return object $DolCardDav
     */
    private function FixLocal(User $user, $row, DolCardDav $DolCardDav) {
        global $db;


        // require 
        dol_include_once('carddav/class/societe.carddav.class.php');
        dol_include_once('carddav/class/contact.carddav.class.php');

        // init 
        $soc = new SocieteCardDav($db);
        $contact = new ContactCardDav($db);

        /**
          First Step
          Search in societe Or Create
         */
        $socid = $soc->SearchAndFix($row);

        if ((int) $socid >= 0) {

            $DolCardDav->UpdateStart($user);

            if ($socid === 0 && $conf->global->CARDDAV_FICHE_TYPE == 'Societe')
                $socid = $soc->create($user);
            else
                $soc->update($socid, $user);
        }

        if ((int) $socid > 0)
            $DolCardDav->fk_socid = (int) $socid;

        /**
          Last Step
          Search in Contact Or Create
         */
        $contactid = $contact->SearchAndFix($row);
        if ((int) $contactid >= 0) {

            if ($contactid === 0)
                $contactid = $contact->create($user);
            else
                $contact->update($contactid, $user);

            $DolCardDav->fk_socid = 0;
            $DolCardDav->fk_contactid = (int) $contactid;
        }



        return $DolCardDav;
    }

    /**
      @fn CheckFileTmp( User $user, $user_carddav)
      @param $user
      @param $user_carddav
      @return $pathfile string Or False
     */
    public static function CheckFileTmp(User $user, $user_carddav) {

        $pathfile = $user_carddav->GetFileNameTmp($user, $user_carddav);

        $date = date('U');

        if (file_exists($pathfile)) {

            $date2 = filemtime($pathfile) + ($user_carddav->frequency * 60 );

            if ($date >= $date2) {

                unlink($pathfile);

                return $pathfile;
            }
        } else
            return $pathfile;

        return false;
    }

    /**
      @param Object $user_carddav
     */
    public function LoadServerAndFixFileTmp($db, $user_carddav, $DolCardDav) {
        global $user;

        $pathfile = self::CheckFileTmp($user, $user_carddav);

        if ($pathfile === false)
            return false;

        // Block triggers specific 
        define('CARDAV_NOTRIGGERS', true);

        $carddav = new carddav_backend($user_carddav->GetServer());
// 		$carddav->enable_debug();
        $carddav->set_auth($user_carddav->carddav_login, $user_carddav->carddav_password);

        $carddav->check_connection();
        $get = $carddav->get();

// 		print_r($get);
// $x = $carddav->get_debug(); 
// echo nl2br($x[0]['header']);
// 		exit;

        $localmail = fopen($pathfile, "a");
        fwrite($localmail, $get);
        fclose($localmail);

        $result = simplexml_load_string($get);

        // collect current list 
        $tmp = array();
        $sql = "SELECT";
        $sql .= " t.rowid,";
        $sql .= " t.carddav_etag,";
        $sql .= " t.carddav_id,";
        $sql .= " t.fk_socid,";
        $sql .= " t.fk_contactid,";
        $sql .= " t.last_modified,";
        $sql .= " t.statut,";
        $sql .= " t.fk_user_carddav,";
        $sql .= " t.fk_user,";
        $sql .= " t.updateprogress";

        $sql .= " FROM " . MAIN_DB_PREFIX . "carddav_link as t";
        $sql .= " WHERE t.fk_user = '" . (int) $user->id . "' ";
        $sql .= " AND t.fk_user_carddav = '" . (int) $user_carddav->id . "' ";

        $resql = $db->query($sql);
        if ($resql) {
            $num = $db->num_rows($resql);

            $i = 0;
            $var = true;
            while ($i < $num) {
                $objp = $db->fetch_object($resql);
                $tmp[$objp->carddav_id] = $objp->rowid;
                $i++;
            }
        }

        $listing = array();
        foreach ($result->element as $k => $row) {

            $row = Synchro::ServerForDol($row->vcard, $row);

            $row = Synchro::CheckLocal($user, $user_carddav, $row);

            // 
            unset($tmp[(string) $row->id]);
            $listing[] = $row;
        }

        // purge reliquat in local db 
        foreach ($tmp as $k => $rowid) {
            $DolCardDav->id = $rowid;
            $DolCardDav->delete($user);
        }

        $user_carddav->update($user);

        return true;
    }

}


