<?php
/* 
 * Copyright (C) 2014 Oscim       <oscim@users.sourceforge.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 *  \file       
 *  \ingroup    
 *  \brief      This file is an example for a CRUD class file (Create/Read/Update/Delete)
 * 			
 */

require_once(DOL_DOCUMENT_ROOT."/contact/class/contact.class.php");


/**
 * 	Put here description of your class
 */
class ContactCardDav
	Extends Contact
{

	/**
		@param $paramobj object param provider by extract vcard
		@return false KO, Int > 0 For ok 
	*/
	public function SearchAndFix($paramobj = false){

		if(!is_object($paramobj))
			return -1; 

		$sql = "SELECT s.rowid as socid, s.nom as name,";
		$sql.= " p.rowid as cidp, p.lastname as lastname, p.statut, p.firstname, p.poste, p.email, p.skype,";
		$sql.= " p.phone, p.phone_mobile, p.fax, p.fk_pays, p.priv, p.tms,";
		$sql.= " cp.code as country_code";
		$sql.= " FROM ".MAIN_DB_PREFIX."socpeople as p";
		$sql.= " LEFT JOIN ".MAIN_DB_PREFIX."c_pays as cp ON cp.rowid = p.fk_pays";
		$sql.= " LEFT JOIN ".MAIN_DB_PREFIX."societe as s ON s.rowid = p.fk_soc";
// 		if (! empty($search_categ)) $sql.= ' LEFT JOIN '.MAIN_DB_PREFIX."categorie_contact as cs ON p.rowid = cs.fk_socpeople"; // We need this table joined to the select in order to filter by categ
// 		if (!$user->rights->societe->client->voir && !$socid) $sql .= " LEFT JOIN ".MAIN_DB_PREFIX."societe_commerciaux as sc ON s.rowid = sc.fk_soc";
		$sql.= " WHERE p.entity IN (".getEntity('carddav', 1).")  AND (   "; 
				
		if(!empty($paramobj->nickname) ){
			$sql.= " p.firstname = '".$this->db->escape($paramobj->nickname )."'   ";
			$sql.= " AND p.lastname = '".$this->db->escape($paramobj->fn )."'  "; 
		}
		else{
			$sql.= " p.firstname = '".$this->db->escape($paramobj->fn )."'   ";
			$sql.= " OR p.lastname = '".$this->db->escape($paramobj->fn )."'  "; 
		}
		
		if(!empty($paramobj->tel))
			$sql.= "OR p.phone = '".$this->db->escape($paramobj->tel)."'   "; 
		if(!empty($paramobj->tel_mob))
			$sql.= " OR p.phone_mobile = '".$this->db->escape($paramobj->tel_mob)."'  "; 
		if(!empty($paramobj->email))
			$sql.= " OR p.email = '".$this->db->escape($paramobj->email)."' ";
			
			$sql.= ")";
			
// 			echo $sql; 
// 			exit;
		$resql=$this->db->query($sql);
		$num=$this->db->num_rows($resql);


		if(!$num || $num<=0){
					$id = 0; 

		}
		else{
			$objp = $this->db->fetch_object($resql);
			$id = $objp->cidp; 
			
			$this->fetch( $objp->cidp); 
		}
		
		
		if(!empty($paramobj->nickname) ) {
			$this->lastname = $paramobj->nickname ;
			$this->firstname = $paramobj->fn ;
		}
		else 
			$this->lastname = $paramobj->fn ;
			
		$this->phone = (!empty($paramobj->phone) ? $paramobj->tel : $paramobj->tel_mob ) ; 
		if( !empty($paramobj->tel_mob) )
			$this->phone_mobile =  $paramobj->tel_mob  ; 
			
		if( !empty($paramobj->fax) )
			$this->fax = $paramobj->fax ; 
			
		if( !empty($paramobj->email) )
			$this->email = $paramobj->email ;
			
		if( !empty($paramobj->birthday) )
			$this->birthday = $paramobj->birthday ;
			
		if( !empty($paramobj->title) )
			$this->poste = $paramobj->title ;
			
			
		return $id; 
	}
	

}
?>