<?php
/* Copyright (C) 2014		 Oscim					       <oscim@users.sourceforge.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 * or see http://www.gnu.org/
 */

/**
 *	\file       htdocs/core/lib/message.lib.php
 *	\brief      Ensemble de fonctions de base pour le module message
 *	\ingroup    message
 */

/**
*  Return array head with list of tabs to view object informations.
*
*  @param	Object	$object		Product
*  @return	array   	        head array with tabs
*/
function user_carddav_prepare_head($object=null)
{
	global $langs, $conf, $user, $db;

	dol_include_once('carddav/class/user.carddav.class.php');
	$user_carddav = new Usercarddavconfig($db);
	
	$h = 0;
	$head = array();

	$head[$h][0] = dol_buildpath("/carddav/index.php",1);
	$head[$h][1] = $langs->trans('MessageDashboard');
	$head[$h][2] = 'dashboard';
	$h++;

	// Show more tabs from modules
	// Entries must be declared in modules descriptor with line
    // $this->tabs = array('entity:+tabname:Title:@mymodule:/mymodule/mypage.php?id=__ID__');   to add new tab
    // $this->tabs = array('entity:-tabname);   												to remove a tab
	complete_head_from_modules($conf,$langs,$object,$head,$h,'message');

	$sql = "SELECT * ";
	$sql.= " FROM ".MAIN_DB_PREFIX."user_carddav";
	$sql.= " WHERE  1 ";
	$sql.= " AND fk_user = '".$user->id."' ";
	$resql = $db->query($sql);
	if ($resql)
	{
		$num = $db->num_rows($resql);

		$i = 0;
		$var=true;
		while ($i < $num)
		{
			$objp = $db->fetch_object($resql);

			$user_carddav->carddav_type = $objp->carddav_type;
			$head[$h][0] = dol_buildpath("/carddav/synchro.php",1).'?number='.$objp->number;
			$head[$h][1] = $user_carddav->GetCardDavType().' '. $objp->number;
			$head[$h][2] = 'synchro'.$objp->number;
			$h++;

			$i++;
		}
	}
	
	
	complete_head_from_modules($conf,$langs,$object,$head,$h,'message','remove');

// 	$head[$h][0] = dol_buildpath("/carddav/info.php?uid=".$obj->$object ,1);
// 	$head[$h][1] = $langs->trans('MessageInfo');
// 	$head[$h][2] = 'info';
// 	$h++;
// 	
// 	$head[$h][0] = dol_buildpath("/carddav/attachment.php?uid=".$obj->$object ,1);
// 	$head[$h][1] = $langs->trans('MessageAttachment');
// 	$head[$h][2] = 'attachment';
// 	$h++;
	
	return $head;
}



function CardDavAdminPrepareHead() {
	global $langs, $conf;

	$langs->load("carddav@carddav");

	$h = 0;
	$head = array();

	$head[$h][0] = dol_buildpath("/carddav/admin/index.php", 1);
	$head[$h][1] = $langs->trans("Note");
	$head[$h][2] = 'info';
	$h++;

	$head[$h][0] = dol_buildpath("/carddav/admin/config.php", 1);
	$head[$h][1] = $langs->trans("Config");
	$head[$h][2] = 'config';
	$h++;
	
	
	$head[$h][0] = dol_buildpath("/carddav/admin/faq.php", 1);
	$head[$h][1] = $langs->trans("Faq");
	$head[$h][2] = 'faq';
	$h++;
	
	$head[$h][0] = dol_buildpath("/carddav/admin/editor.php", 1);
	$head[$h][1] = $langs->trans("Editor");
	$head[$h][2] = 'editor';
	$h++;
	
	$head[$h][0] = dol_buildpath("/carddav/admin/abouts.php", 1);
	$head[$h][1] = $langs->trans("About");
	$head[$h][2] = 'about';
	$h++;

// 	complete_head_from_modules($conf, $langs, $object, $head, $h, 'carddav');

// 	complete_head_from_modules($conf, $langs, $object, $head, $h, 'carddav', 'remove');

	return $head;
}
?>
