<?php
/* Copyright (C) 2014		 Oscim					       <oscim@users.sourceforge.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 *	\defgroup   CardDavMods      Module 
 *	\brief      
 */

Class CardDavMods {
	/**
		@var  object usercarddavconfig 
	*/
	protected $currentobject ;
	/**
		@var string path specific for access ressource
	*/
	protected $path = '/addressbooks/__carddav_login__/__carddav_dir__/';
	/**
		@var  array list of extra 
	*/
	protected $extra = array(); 
	/**
		@var array list of vars 
	*/
	protected $list_vars= array(
		);
	
	
	
	function __construct($object){
		$this->currentobject = $object;
		
		$this->GetListVars();
		$this->ExtractExtra(); 

	}
	

	
	/**
		@brief 
		@return none
	*/

	function ExtractExtra(){
		$list = explode( '/', $this->path); 
		
		foreach($list as $row)
			if(preg_match('#__([a-z0-9_]*)__#i', $row, $match) ){
				$key = $match[1]; 
				
				$this->extra['__'.$key.'__'] = array(
					'key'=> $key,
					'value'=> ( (isset($this->currentobject->$key) && !empty($this->currentobject->$key) )? $this->currentobject->$key : $this->list_vars['__'.$key.'__'])
				);
			}
	}
	/**
		@brief 
		@return none
	*/
	function GenerateDir($nofolder=false){
	
			$path = (($this->currentobject->carddav_ssl==1)? 'https' : 'http' );
			
			$path .='://'.$this->currentobject->carddav_host; 
			
			if($this->currentobject->carddav_port > 0 )
				$path .=':'.$this->currentobject->carddav_port; 
			
			if($this->currentobject->carddav_path !='' ){
				if(substr($this->currentobject->carddav_path, -1) !='/' ) 
					$this->currentobject->carddav_path .='/'; 
					
				$path .='/'.$this->currentobject->carddav_path; 
			}
			
		$repl = array();
		$val = array();
		foreach($this->extra as $key => $value){
			$repl[] = $key; 
			$val[] = $value['value']; 
		}

		$path .= str_replace($repl, $val, $this->path );
		return $path; 
	}
	
	
	
	
	/**
		@fn GetListVars()
		@brief Get Value 
		@return array value 
	*/
	public function GetListVars(){
		return $this->list_vars;
	}

	/**
		@fn SetListVars()
		@brief Get Value 
		@param $list_vars array  list of vars 
	*/
	public function SetListVars($list_vars){
		$this->list_vars = $list_vars;
	}

	/**
		@fn GetPath()
		@brief Get Value 
		@return string value 
	*/
	public function GetPath(){
		return $this->path;
	}

	/**
		@fn SetPath()
		@brief Get Value 
		@param $path string  path specific for access ressource
	*/
	public function SetPath($path){
		$this->path = $path;
	}

	/**
		@fn GetTitle()
		@brief Get Value 
		@return  value 
	*/
	public function GetTitle(){
		return $this->title;
	}

	/**
		@fn SetTitle()
		@brief Get Value 
		@param $title   String Name of module
	*/
	public function SetTitle($title){
		$this->title = $title;
	}
}


class GenericCardDav
	Extends CardDavMods{
	/**
		@var array list of vars 
	*/
	protected $list_vars= array(
		 '__carddav_login__'=>''
		,'__carddav_dir__'=>'default'
		);
	
	/**
		@var  String Name of module
	*/
	protected $title = 'Generic';

	/**
		@var string path specific for access ressource
	*/
	protected $path = '/addressbooks/__carddav_login__/__carddav_dir__/';


	





}

?>
