<?php
/* Copyright (C) 2014		 Oscim					       <oscim@users.sourceforge.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/**
 *	    \file       htdocs/comm/action/listactions.php
 *      \ingroup    agenda
 *		\brief      Page to list actions
 *		\version    $Id: listactions.php,v 1.39.2.1 2011/01/19 11:17:18 eldy Exp $
 */

$res = 0;
if (!$res && file_exists("../main.inc.php"))
    $res = @include("../main.inc.php");
if (!$res && file_exists("../../main.inc.php"))
    $res = @include("../../main.inc.php");
if (!$res && file_exists("../../../main.inc.php"))
    $res = @include("../../../main.inc.php");
if (!$res && file_exists("../../../../main.inc.php"))
    $res = @include("../../../../main.inc.php");
if (!$res && file_exists("../../../dolibarr/htdocs/main.inc.php"))
    $res = @include("../../../dolibarr/htdocs/main.inc.php");     // Used on dev env only
if (!$res && file_exists("../../../../dolibarr/htdocs/main.inc.php"))
    $res = @include("../../../../dolibarr/htdocs/main.inc.php");   // Used on dev env only
if (!$res && file_exists("../../../../../dolibarr/htdocs/main.inc.php"))
    $res = @include("../../../../../dolibarr/htdocs/main.inc.php");   // Used on dev env only
if (!$res)
    die("Include of main fails");
require_once(DOL_DOCUMENT_ROOT."/contact/class/contact.class.php");
require_once(DOL_DOCUMENT_ROOT."/comm/action/class/actioncomm.class.php");
require_once(DOL_DOCUMENT_ROOT."/core/lib/date.lib.php");
require_once(DOL_DOCUMENT_ROOT."/core/lib/agenda.lib.php");
if ($conf->projet->enabled) require_once(DOL_DOCUMENT_ROOT."/core/lib/project.lib.php");
require_once(DOL_DOCUMENT_ROOT."/societe/class/societe.class.php");
require_once(DOL_DOCUMENT_ROOT."/core/lib/functions2.lib.php");
require_once(DOL_DOCUMENT_ROOT."/core/lib/company.lib.php");

dol_include_once('carddav/class/carddav.class.php');
dol_include_once('carddav/class/Synchro.class.php');
dol_include_once('carddav/class/user.carddav.class.php');
dol_include_once('carddav/class/DolCardDav.class.php');


$langs->load("companies");
$langs->load("agenda");
$langs->load("carddav@carddav");

$action=GETPOST('action','alpha');
$year=GETPOST("year",'int');
$month=GETPOST("month",'int');
$day=GETPOST("day",'int');
$pid=GETPOST("projectid",'int');
$status=GETPOST("status",'alpha');

// Security check
$socid = GETPOST("socid",'int');
if ($user->societe_id) $socid=$user->societe_id;

$soc = new Societe($db);
$soc->id = $socid;
$soc->fetch($socid);
$soc->info($socid);

// $result = restrictedArea($user, 'agenda', 0, '', 'myactions');
// 
// $canedit=1;
// if (! $user->rights->agenda->myactions->read) accessforbidden();
// if (! $user->rights->agenda->allactions->read) $canedit=0;
// if (! $user->rights->agenda->allactions->read || $_GET["filter"]=='mine')	// If no permission to see all, we show only affected to me


$user_carddav = new Usercarddavconfig($db);
$DolCardDav = new DolCardDav($db); 
$result = array();



switch($action){

	case 'update':

		$Static = $DolCardDav ;
		$res = $Static->fetch_from($user->id, '', $soc->id,0,'',false); 
	
		$sql = "SELECT * ";
		$sql.= " FROM ".MAIN_DB_PREFIX."user_carddav";
		$sql.= " WHERE  1 ";
		$sql.= " AND fk_user = '".$user->id."' ";
		$resql = $db->query($sql);
		if ($resql)
		{
			$num = $db->num_rows($resql);

			$i = 0;
			$var=true;
			while ($i < $num)
			{
				$objp = $db->fetch_object($resql);
			
				$user_carddav->fetch($objp->rowid);
				$DolCardDav = new DolCardDav($db); 
				$res = $DolCardDav->fetch_from($user->id, '', $soc->id,0,'',false, $objp->rowid); 


				if($res >  0) {
					$DolCardDav->statut = ((isset($_POST['synchro'][$objp->rowid]) && $_POST['synchro'][$objp->rowid]==1) ? 1 : 0 );
					$DolCardDav->update($user); 
				}
				elseif(isset($_POST['synchro'][$objp->rowid]) && $_POST['synchro'][$objp->rowid]==1){

					$vcard = Synchro::DolForServer($soc);

					$carddav = new carddav_backend( $user_carddav->GetServer() );

					$carddav->set_auth($user_carddav->carddav_login, $user_carddav->carddav_password);
					
					$carddav->check_connection();
					$vcard_id = $carddav->add($vcard);

					
					$DolCardDav->statut = (int)1;
					$DolCardDav->carddav_id= $vcard_id;
					$DolCardDav->fk_user = (int)$user->id;
					$DolCardDav->fk_user_carddav = (int)$objp->rowid;

						
					$DolCardDav->fk_socid =  $soc->id; 
					
					$DolCardDav->create( $user ); 
					
					$DolCardDav->UpdateEnd( $user ); 
				}
		
				$i++;
			}
		}
		
		Header("location: ".dol_buildpath('/carddav/tabs/societe.carddav.php', 1).'?socid='.$socid  );
		exit;
	break; 
	
	default : 


		$sql = "SELECT * ";
		$sql.= " FROM ".MAIN_DB_PREFIX."user_carddav";
		$sql.= " WHERE  1 ";
		$sql.= " AND fk_user = '".$user->id."' ";
		$resql = $db->query($sql);
		if ($resql)
		{
			$num = $db->num_rows($resql);

			$i = 0;
			$var=true;
			while ($i < $num)
			{
				$objp = $db->fetch_object($resql);
			
				$user_carddav->fetch($objp->rowid);
				
				$res = $DolCardDav->fetch_from($user->id, '', $soc->id,0,'',false, $objp->rowid);  //$DolCardDav->fetch_from($user->id, '', $soc->id); 

				
				$o = new StdClass();
				$o->id = $objp->rowid; 
				$o->addressbook_link = '<a href="'.dol_buildpath('/carddav/synchro.php?number='.$user_carddav->number, 1).'">'.$user_carddav->GetCardDavType().' '.$user_carddav->number.'</a>';
				
				if($res){
					$o->linkcarddav = ( ($DolCardDav->statut==1)? true : false ); 
					$o->last_modified = $DolCardDav->last_modified; 
				}
				else{
					$o->linkcarddav = false; 
					$o->last_modified ='' ;
				}
				$result[] = $o; 
				
				$i++;
			}
		}

}
/*
 *  View
 */

 
 
/*
 * Affichage onglets
 */

$help_url='EN:Module_Agenda_En|FR:Module_Agenda|ES:M&omodulodulo_Agenda';
llxHeader('',$langs->trans("Agenda"),$help_url);


$head = societe_prepare_head($soc);
dol_fiche_head($head, 'TabCardDav', $langs->trans("ThirdParty"),0,'company');
$form=new Form($db);

$societe = new Societe($db);
$societe->fetch($socid);

print_barre_liste($langs->trans($title).' '.$langs->trans("For").' '.$societe->nom, $page, $_SERVER["PHP_SELF"], $param,$sortfield,$sortorder,'',$num);



dol_include_once('/carddav/tpl/societe.tab.tpl');


$db->close();

llxFooter('$Date: 2011/01/19 11:17:18 $ - $Revision: 1.39.2.1 $');
?>
