<?php
/* Copyright (C) 2016		 Oscss-Shop       <support@oscss-shop.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 * or see http://www.gnu.org/
*/


/**
 *	@file    class/actions_framework.class.php
 *	@ingroup framework
 *	@brief   Hook for framework
 *	Support of Greffons
 */

dol_include_once('/framework/class/hookgreffon.class.php');

/**
 *	@class ActionsFramework
 *	@brief
 */
class ActionsFramework extends HookGreffon
{
	/**
	 * addMoreActionsButtons
	 *
	 * @param  mixed $parameters
	 * @param  mixed $object
	 * @param  mixed $action
	 * @param  mixed $hookmanager
	 * @return void
	 */
	function addMoreActionsButtons($parameters, &$object, &$action, $hookmanager)
	{
		global $conf, $langs, $user, $db, $mysoc;

		if (isset($conf->fkbutton) && $conf->fkbutton->enabled)
			if (in_array('globalcard', explode(':', $parameters['context']))) {

				$list = array();
				$return = 0;

				$cl = explode('\\', get_class($object));
				$typedoc = strtolower($cl[count($cl) - 1]);

				dol_include_once('/framework/class/fixversion.class.php');
				$FV = new Fixversion($this->db);
				$type = $FV->GetTypeByClassName($typedoc);
				// 			var_dump($type);
				if (!is_string($type))
					return 0;

				$sql = "SELECT b.name, b.label, b.title, b.url, b.css_class,  .b.lang, .bc.type, bc.fk_button, bc.eval, bc.result FROM " . MAIN_DB_PREFIX . "button_check as bc LEFT JOIN " . MAIN_DB_PREFIX . "button as b ON(b.rowid=bc.fk_button) WHERE b.type='" . $type . "' ORDER BY  FIELD (bc.type, 'view', 'use'), sort  ";

				$resql = $this->db->query($sql);
				$i = 0;
				$nodisplay = array();
				$num = $this->db->num_rows($resql);
				while ($i < $num) {
					$i++;
					$err = $ok = 0;
					$button = $this->db->fetch_object($resql);

					if (!empty($button->eval)) {

						$r = eval(' $check = (' . preg_replace("#\n|\t|\r#", " ", $button->eval) . ');');

						$rescheck = explode(':', $button->result);

						// 					echo $button->eval."\"";

						if (isset($check) && (bool) $rescheck[1] == (bool) $check)
							$ok++;
						else {
							if ($rescheck[2] == 'refused')
							$button->refused = true;
							else
								$err++;
						}
					}

					if ($button->type == 'view' && $err > 0)
						$nodisplay[$button->name] = $button->name;
					elseif ($button->type == 'view' && $err == 0 && in_array($button->name, $nodisplay))
						unset($nodisplay[$button->name]);


					if ($err == 0 && !in_array($button->name, $nodisplay))
						$list[$button->name] = $button;
					elseif (isset($list[$button->name])  && $err > 0) {
						unset($list[$button->name]);
					}



					//
					// 						var_dump( $button->name);
					// 						var_dump( ((bool)$rescheck[1] ==(bool)$check) ,  $ok,$err, $button->type);

				}

				// 			 print_r($nodisplay);

				if (is_array($list) && count($list) > 0)
					foreach ($list as $button) {
						if (!empty($button->lang)) {
							// 				var_dump($button->lang,$button->label,$langs->trans((string)$button->label)  );
							$langs->load($button->lang);
						}
						$url = str_replace('__ID__', $object->id, $button->url);
						$r = @eval('$url = \'' . stripcslashes($url) . '\';');

						if ($r) {
							// 				var_dump( $button->name, $r, '$url = \''.stripcslashes($button->url).'\';');
						}
						$classcss = $button->css_class . ' ';
						if ($button->refused) {
							$url = '#';
							$classcss .= 'butActionRefused';
						}

						print '<div class="inline-block divButAction"><a class="' . $classcss . '" href="' . dol_buildpath($url, 2) . '" title="' . $button->title . '">' . $langs->trans(trim($button->label)) . '</a></div>' . "\n";

						$return++;
					}

				if ($return != 0)
					return 1;
				else
					return 0;
			}

		return 0;
	}


	/**
	 * Overloading the doActions function : replacing the parent's function with the one below
	 *
	 * @param   array()         $parameters     Hook metadatas (context, etc...)
	 * @param   CommonObject    &$object        The object to process (an invoice if you are in invoice module, a propale in propale's module, etc...)
	 * @param   string          &$action        Current action (if set). Generally create or edit or null
	 * @param   HookManager     $hookmanager    Hook manager propagated to allow calling another hook
	 * @return  int                             < 0 on error, 0 on success, 1 to replace standard code
	 */
	function updateSession($parameters, &$object, &$action, $hookmanager)
	{

		// $parameters['context'].= ':greffon:framework';
		return $this->{'___'.__FUNCTION__}($parameters, $object, $action, $hookmanager);
	}


	/**
	 *	@fn GetTbl($table)
	 *	@brief
	 */
	public function __call($name, $args)
	{
		global $conf;

		if (substr($name, 0, 3) === '___')
		$name = substr($name, 3);
		else
			return 0;

		$return = 0;
		$args[0]['context'] .= ':greffon:framework';
		$contexts = explode(':', $args[0]['context']);

		$this->initGreffon($contexts);

		if (in_array('greffon', $contexts) && in_array('framework', $contexts)) {

			if (isset($this->greffon['framework']) && is_array($this->greffon['framework']))
				foreach ($this->greffon['framework'] as $k => $r) {

					if (method_exists(get_class($r), $name)) {
						$result = $r->$name($args[0], $args[1], $args[2], $args[3]);

						if ($result)
							foreach ($r->results as $key => $v)
								$res[$key] = $v;
					}
				}

			$this->resprints = '';

			if (isset($args[0]['titles']) && is_array($args[0]['titles']))
				foreach ($args[0]['titles'] as $k => $arr) {
					if (isset($res[$k])) {
						$this->resprints .= $res[$k];
					} else
						$this->resprints .= $arr;
				}

			return 1;
		}

		return $return;
	}
}
