<?php
/* Copyright (C) 2016		 Oscss-Shop       <support@oscss-shop.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 * or see http://www.gnu.org/
 */

class apiClient {

    private $timeout, $username, $password;

    public $curl_response
        /**
		 *	@var result of request
		 */
        , $decoded
        /**
		 *	@var
		 */
        , $info
        /**
		 *	@var code http response
		 */
        , $http_code
        /**
		 *	@var content type
		 */
        , $content_type
         /**
		 *	@var
		 */
        , $use_time_delta = false
         /**
		 *	@var
		 */
        , $end_point = '';

    /**
	 *	@var this param specifie retrun in send method;
	 *		if false send() retrun true if ok
	 *		if true send rerturn curl_response
     */
    protected $mode = false;
    /**
	 *	@fn
	 *	@brief construct
	 *	@param string $user
	 *	@param string $password
     */
    public function __construct($user = "", $password = "")
    {
        $this->timeout = 10;
        $this->username = "$user";
        $this->password = "$password";
    }

    /**
		@fn FixMode()
		@param bool $return
    */
	public function FixMode($return = false){
		if($return == 'download')
			$this->mode = 'download';
		if($return)
			$this->mode = true;
	}

    /**
	*	@fn  send()
	*	@brief
	*	@param string $url
	*	@param array $curl_post_data
	*	@param string $method
	*	@param string $additionalHeaders
	*	@return
    */

    public function send($url, $curl_post_data = array(), $method = "GET", $additionalHeaders = array() ) {

		$this->end_point = trim($this->end_point);
		if(substr($this->end_point, -1) !='/' && substr($url,0, 1) !='/' )
			$this->end_point.='/';

        /// WARNING ! the end point modify the URL ???  don't knwo why
        if(substr( $url, 0, 4 ) !== "http")
            $url = $this->end_point.$url;
// echo $url; 
		if(!is_array($additionalHeaders) && !empty($additionalHeaders)  )
			$additionalHeaders = array($additionalHeaders);


		if(is_array($curl_post_data))
			$additionalHeaders[] = 'Content-Length: ' . strlen($data);


		$this->info_url = $url;
		$this->info_method =$method;
// echo $method.$url.'<br> '; 
        $process = curl_init($url);
        curl_setopt($process, CURLOPT_TIMEOUT, $this->timeout);
        curl_setopt($process, CURLOPT_CONNECTTIMEOUT, $this->timeout);

        if(is_bool($this->mode) &&  $this->mode)
			curl_setopt($process, CURLOPT_HTTPHEADER, $additionalHeaders);

        curl_setopt($process, CURLOPT_BINARYTRANSFER,1);
//for debug header
		curl_setopt($process, CURLOPT_FOLLOWLOCATION, 1);
        curl_setopt($process, CURLOPT_HEADER, true);
        curl_setopt($process, CURLINFO_HEADER_OUT, true);
        curl_setopt($process, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
        curl_setopt($process, CURLOPT_USERPWD, $this->username . ":" . $this->password);
        curl_setopt($process, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($process, CURLOPT_SSL_VERIFYHOST, false);
        curl_setopt($process, CURLOPT_RETURNTRANSFER, true);
// the method is here :
        curl_setopt($process, CURLOPT_CUSTOMREQUEST, $method);
        if (is_string($curl_post_data)) { // already converted to string previously (json)
            curl_setopt($process, CURLOPT_POST, true);
            curl_setopt($process, CURLOPT_POSTFIELDS, $curl_post_data);
        } elseif ($curl_post_data !== array()) { // its an array and not empty
            curl_setopt($process, CURLOPT_POST, true);
            curl_setopt($process, CURLOPT_POSTFIELDS, http_build_query($curl_post_data));
        }




        // send data
        $this->curl_response = curl_exec($process);
        $header_size = curl_getinfo($process, CURLINFO_HEADER_SIZE);
        $this->curl_response = substr($this->curl_response, $header_size);
        // exctract header from data
        if ($this->curl_response === false) {
            $this->http_code = curl_getinfo($process, CURLINFO_HTTP_CODE);
            $this->info = curl_getinfo($process);
            die("error occured during curl exec. Additioanl info: code({$this->http_code}) " . curl_error($process));

        } else {
            // debug
               $info = curl_getinfo($process);
//                var_dump($info);
            $this->http_code = curl_getinfo($process, CURLINFO_HTTP_CODE);

        }


		$this->content_type = curl_getinfo($process,  CURLINFO_CONTENT_TYPE);

 
		if(preg_match('#(json)#i',$this->content_type) )
			$this->decoded = json_decode($this->curl_response);
		else
			$this->decoded = $this->curl_response;

		curl_close($process);
        switch (json_last_error()) {
            case JSON_ERROR_NONE:
                break;
            case JSON_ERROR_DEPTH:
                return json_encode('JSON_ERROR - Maximum stack depth exceeded');
                break;
            case JSON_ERROR_STATE_MISMATCH:
                return json_encode('JSON_ERROR - Underflow or the modes mismatch');
                break;
            case JSON_ERROR_CTRL_CHAR:
                return json_encode('JSON_ERROR - Unexpected control character found');
                break;
            case JSON_ERROR_SYNTAX:
                return json_encode('JSON_ERROR - Syntax error, malformed JSON');
                break;
            case JSON_ERROR_UTF8:
                return json_encode('JSON_ERROR - Malformed UTF-8 characters, possibly incorrectly encoded');
                break;
            default:
                return json_encode('JSON_ERROR - Unknown error');
                break;
        }

        if($this->mode )
			return $this->curl_response;

        return true;
    }


	/**
     * Calculate time delta between local machine and API's server
     *
     * @return int
     */
    protected function calculateTimeDelta()
    {
        if (!isset($this->time_delta)) {
            $serverTimestamp         = $this->send(
                "/auth/time",
                null,
                'GET',
                ""
            );
            $this->time_delta = (int) $serverTimestamp - (int) \time();
        }

        return $this->time_delta;
    }

}
