<?php
/* Copyright (C) 2016		 Oscss-Shop       <support@oscss-shop.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 * or see http://www.gnu.org/
 */
 
 
/**
*	@class checkcronjob
*	@brief class intended to catch up with the classes remaining in a processing state after their launch
*		An email is sent to the user cron spots for info
*/
class checkcronjob {

	
	/**
	 * __construct
	 *
	 * @param  mixed $db
	 * @return void
	 */
	function __construct($db){
// 		$this->db = $db; 
	}
	
	
	/**
	 * Action executed by scheduler
	 * CAN BE A CRON TASK. In such a case, parameters come from the schedule job setup field 'Parameters'
	 *
	 * @return	int			0 if OK, <>0 if KO (this function is used also by cron so only 0 is OK)
	 */
	//public function doScheduledJob($param1, $param2, ...)
	public function doScheduledJob()
	{
		global $conf, $langs, $user;

		//$conf->global->SYSLOG_FILE = 'DOL_DATA_ROOT/dolibarr_mydedicatedlofile.log';

		$max_execution_time = ini_get('max_execution_time');
		$max_execution_time += 90;
		// 		if(!is_object($this->db)){
		global $db;
		$this->db = $db;
		// 		}

		$error = 0;
		$this->output = '';
		$this->error = '';

		dol_syslog(__METHOD__, LOG_DEBUG);

		$now = dol_now();

		$this->db->begin();

		// ...
		$sql = " SELECT rowid , label FROM " . MAIN_DB_PREFIX . "cronjob WHERE processing = 1 AND  objectname != 'checkcronjob' AND datelastrun <= '" . date("Y-m-d H:i:s", strtotime('now +' . $max_execution_time . ' seconds')) . "' ";

		$resql = $this->db->query($sql);
		if ($resql) {
			$num = $this->db->num_rows($resql);
			$i = 0;

			if ($num) {
				while ($i < $num) {
					$obj = $this->db->fetch_object($resql);

					$resql2 = $this->db->query("UPDATE " . MAIN_DB_PREFIX . "cronjob SET processing=0 WHERE rowid = " . $obj->rowid . " ");

					// TODO put mail or log !!!

					mail($user->email,  'ReactiveCronJob', $obj->label);

					$i++;
				}

				$this->db->free($resql);

				$this->db->commit();
			}

			return $error;
		}
	}
}
